#include "task_audio.h"
#include "vs1011e.h"
#include "kozos.h"
#include "pff.h"

#define AUDIO_CMD_PULSE  'p'

void audio_pulse(void)
{
  char *p;
  p = kz_kmalloc(1);
  p[0] = AUDIO_CMD_PULSE;
  kz_send(MSGBOX_ID_AUDIO, 1, p);
}

static int audio_cmdproc(char *p)
{
  int cmd = p[0];
  volatile int i;
  switch (cmd) {
  case AUDIO_CMD_PULSE:
    vs1011e_sinetest_init();
    for (i = 0; i < 1000; i++) { }
    vs1011e_sinetest_fini();
    for (i = 0; i < 1000; i++) { }
    break;
  default:
    break;
  }
  kz_kmfree(p);

  return 0;
}

int readfunc(void * buf, const int len)
{
    WORD cnt;
    pf_read(buf, len, &cnt);
    kz_wait();
    return cnt;
}

static int play(const char *filename)
{
    FRESULT r = pf_open("splash.mp3");
    if (r != FR_OK) {
        return 1;
    }
    int siz = 512;
    void *p = kz_kmalloc(siz);
    vs1011e_play(p, siz, readfunc);
    kz_kmfree(p);
    return 0;
}

int task_audio(int argc, char *argv[])
{
  int size;
  char *p;

#if 0
  /*
   * mp3$B%U%!%$%k$N:F@8%F%9%H!#(B
   */
  FATFS fatfs;
  DIR dir;
  FILINFO filinfo;

  vs1011e_volume_write(0x02, 0x02);
  while (1) {
      if (pf_mount(&fatfs)) {
          continue;
      }
      while (1) {
          if (pf_opendir(&dir, "")) {
              break;
          }
          while (!pf_readdir(&dir, &filinfo) && filinfo.fname[0]) {
              if (!(filinfo.fattrib & (AM_DIR | AM_HID))) {
                  if (play(filinfo.fname)) {
                      break;
                  }
              }
          }
      }
  }
#endif

  while (1) {
    kz_recv(MSGBOX_ID_AUDIO, &size, &p);
    audio_cmdproc(p);
  }

  return 0;
}

